GNU Radio C++ API Reference: gr::filter::kernel::polyphase_filterbank Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::filter::kernel::polyphase_filterbank Class Reference
GNU Radio C++ Signal Processing Blocks » Filters

Polyphase filterbank parent class. More...

`#include <gnuradio/filter/polyphase_filterbank.h>`

## Public Member Functions
| polyphase_filterbank (unsigned int nfilts, const std::vector< float > &taps)
virtual | ~polyphase_filterbank ()=default
virtual void | set_taps (const std::vector< float > &taps)
void | print_taps ()
std::vector< std::vector< float > > | taps () const

## Protected Attributes
unsigned int | d_nfilts
std::vector< kernel::fir_filter_ccf > | d_fir_filters
std::vector< kernel::fft_filter_ccf > | d_fft_filters
std::vector< std::vector< float > > | d_taps
unsigned int | d_taps_per_filter
fft::fft_complex_rev | d_fft

## Detailed Description

Polyphase filterbank parent class.

This block takes in complex inputs and channelizes it to M channels of equal bandwidth. Each of the resulting channels is decimated to the new rate that is the input sampling rate fs divided by the number of channels, M.

The PFB channelizer code takes the taps generated above and builds a set of filters. The set contains M filters and each filter contains ceil(taps.size()/decim) taps. Each tap from the filter prototype is sequentially inserted into the next filter. When all of the input taps are used, the remaining filters in the filterbank are filled out with 0's to make sure each filter has the same number of taps.

Each filter operates using the gr::filter::fir_filter_XXX class of GNU Radio, which takes the input stream at i and performs the inner product calculation to i+(n-1) where n is the number of filter taps. To efficiently handle this in the GNU Radio structure, each filter input must come from its own input stream. So the channelizer must be provided with M streams where the input stream has been deinterleaved. This is most easily done using the gr::blocks::stream_to_streams block.

The output is then produced as a vector, where index i in the vector is the next sample from the ith channel. This is most easily handled by sending the output to a gr::blocks::vector_to_streams block to handle the conversion and passing M streams out.

The input and output formatting is done using a hier_block2 called pfb_channelizer_ccf. This can take in a single stream and outputs M streams based on the behavior described above.

The filter's taps should be based on the input sampling rate.

For example, using the GNU Radio's firdes utility to building filters, we build a low-pass filter with a sampling rate of fs, a 3-dB bandwidth of BW and a transition bandwidth of TB. We can also specify the out-of-band attenuation to use, ATT, and the filter window function (a Blackman-harris window in this case). The first input is the gain of the filter, which we specify here as unity.

self._taps = filter.firdes.low_pass_2(1, fs, BW, TB, attenuation_dB=ATT, window=fft.window.WIN_BLACKMAN_hARRIS)

More on the theory of polyphase filterbanks can be found in the following book:

f. harris, "Multirate Signal Processing for Communication Systems," Upper Saddle River, NJ: Prentice Hall, Inc. 2004.

## Constructor & Destructor Documentation

## ◆ polyphase_filterbank()

gr::filter::kernel::polyphase_filterbank::polyphase_filterbank | ( | unsigned int | nfilts,
|  | const std::vector< float > & | taps )

Build the polyphase filterbank decimator.

Parameters

  nfilts | (unsigned integer) Specifies the number of channels M
  taps | (vector/list of floats) The prototype filter to populate the filterbank.

References taps().

## ◆ ~polyphase_filterbank()

virtual gr::filter::kernel::polyphase_filterbank::~polyphase_filterbank | ( |  | ) |
| virtualdefault

## Member Function Documentation

## ◆ print_taps()

void gr::filter::kernel::polyphase_filterbank::print_taps | ( |  | ) |

Print all of the filterbank taps to screen.

## ◆ set_taps()

virtual void gr::filter::kernel::polyphase_filterbank::set_taps | ( | const std::vector< float > & | taps | ) |
| virtual

Update the filterbank's filter taps from a prototype filter.

Parameters

  taps | (vector/list of floats) The prototype filter to populate the filterbank.

References taps().

## ◆ taps()

std::vector< std::vector< float > > gr::filter::kernel::polyphase_filterbank::taps | ( |  | ) | const

Return a vector<vector<>> of the filterbank taps

Referenced by polyphase_filterbank(), and set_taps().

## Member Data Documentation

## ◆ d_fft

fft::fft_complex_rev gr::filter::kernel::polyphase_filterbank::d_fft
| protected

## ◆ d_fft_filters

std::vector<kernel::fft_filter_ccf> gr::filter::kernel::polyphase_filterbank::d_fft_filters
| protected

## ◆ d_fir_filters

std::vector<kernel::fir_filter_ccf> gr::filter::kernel::polyphase_filterbank::d_fir_filters
| protected

## ◆ d_nfilts

unsigned int gr::filter::kernel::polyphase_filterbank::d_nfilts
| protected

## ◆ d_taps

std::vector<std::vector<float> > gr::filter::kernel::polyphase_filterbank::d_taps
| protected

## ◆ d_taps_per_filter

unsigned int gr::filter::kernel::polyphase_filterbank::d_taps_per_filter
| protected

The documentation for this class was generated from the following file:

- polyphase_filterbank.h